NB. read/write comma-separated value data (*.csv) files

NB. main definitions:
NB.      readcsv file    - reads data into a boxed array
NB.  dat writecsv file   - writes a boxed array to a csv file

require 'files strings'

cocurrent 'z'

NB. =========================================================
extcsv=: , #&'.csv' @ (0: = '.'"_ e. (# | i:&PATHSEP_j_) }. ])

NB. =========================================================
chopcsv=: 3 : 0
dat=. y.,','
b=. dat e. ','
c=. ~:/\dat='"'
msk=. b>c
if. 0=+/msk do. msk=. (#msk){.1 end.
dat=. msk <;._2 dat
b=. '"'={.@(1&{.) &> dat
dat=. b }.each dat
b=. '"'={.@(_1&{.) &> dat
dat=. (-b) }.each dat
)

NB. =========================================================
NB.*fixcsv v convert csv data into J array
fixcsv=: 3 : 0
b=. y. e. LF
c=. ~:/\y.='"'
msk=. b > c
> msk <@chopcsv ;._2 y.
)

NB. =========================================================
NB.*readcsv v reads csv file into a boxed array
readcsv=: 3 : 0
dat=. freads extcsv y.
if. dat -: _1 do. return. end.
fixcsv dat
)

NB. =========================================================
NB.*writecsv v writes a boxed array to a csv file
writecsv=: 4 : 0
dat=. '"'&, @ (,&'",') @ ": each x.
f=. <@(,&LF)@}:@;
dat=. ;f"1 dat
dat fwrites extcsv y.
)


