NB. built from project: ~Source\classes\grid\report\report
NB. jfgrid class


coclass 'jfgrid'
require'jzgrid'
coextend 'jzgrid'

NB. =========================================================
resetatts=: 3 : 0
j=. (WHITE,SILVER,BLACK,1 2 _1),(SILVER,WHITE,BLACK,0 _1 1),:SILVER,128 255 255,BLACK,0 _1 _1
atts=: 3 20 {. j
)

NB. =========================================================
create=: 3 : 0
create_jzgrid_ f. y.
firsttime=: 1
resetatts''
fixr=: 2
fixc=: 1
editenable=: 1
filltype=: 0
fixtype=: 0
fixeddata=: 0
sizeenable=: 1
maxc=: 14
maxr=: 13
)

NB. =========================================================
destroy=: 3 : 0
destroy_jzgrid_ f. y.
)

NB. =========================================================
setdata=: 3 : 0
getreqrc''
d=. ".dataname
d=. ((0{$d),12){.d
(dataname)=: d
shape=: $d
d=. d,+/d
d=. d,.+/"1 d
s=. 2 1+$d
setgrid s
setwidths 100,(12$60),100
setheights (0{s)$20
0 1 1 13 settext'1st quarter';'';'';'2nd quarter';'';'';'3rd quarter';'';'';'4th quarter';'';'';'totals'
settype (12$0 _1 _1),0
1 1 1 13 settext 'Jan';'Feb';'Mar';'Apr';'May';'June';'July';'Aug';'Sept';'Oct';'Nov';'Dec';''
settype 13$0
(0 0, (0{s), 1) settext ('';''),(<'item '),each":each<"0 i.0{shape
(2 1,$d) settext d
(2 1,shape) settype (shape)$1
(2 13, (0{$d) ,1) settype (0{$d)$2
((1+0{$d),1 1 12) settype 12$2
b=. (0{$d),3,16$11 255 0 0
border=. 2 1,b,2 4,b,2 7,b,2 10,b
setborder border
if. #sbarid do.
  wd'set ',sbarid,' 0 0 ',(":1{shape),' 1' end.
if. #sbarvid do.
  wd'set ',sbarvid,' 0 0 ',(":0{shape),' 1' end.
)

NB. =========================================================
setnewdata=: 3 : 0
d=. ".dataname
d=. d,+/d
d=. d,.+/"1 d
glgridinvalidate 1
(2 1 ,$d) settext d
glgridinvalidate 0
)

NB. =========================================================
NB. update data - x. new data -  y. index
seteditdata=: 3 : 0
'ix data'=. y.
index=. <_2 _1+ix
data=. ".data
".dataname,'=:data index}',dataname
setnewdata ''
0
)

NB. =========================================================
NB. get marked cell raw formatted data for editing
getedit=: 3 : 0
toHOST":>".'(< y. - 2 1){',dataname  NB.! toHOST
)

NB. =========================================================
fixcopy=: 3 : 0
t=. toJ y.
t=. t rplc '"';'""'
t=. '"',t,'"'
)

NB. =========================================================
copy=: 3 : 0
t=. ''
m=. mark-fixr,fixc
ex=. extent
r=. 0{ex
c=. 1{ex
index=. (0{m)+i.0{ex
index=. <index ; (1{m)+i.1{ex
t=. ".'index{',dataname
t=. ":each t
t=. fixcopy each t
t=. t,each ((r,c-1)$<TAB),.r$<CRLF
t=. ;t
wd'clipcopy *',t
)

NB. =========================================================
fixpaste=: 3 : 0
if. '"' ~: 0{y. do. y. return. end.
  y=. _1}.1}.y.
  y rplc '""';'"'
)

NB. =========================================================
NB. assumes rectangular
paste=: 3 : 0
t=. wd'clippaste'
b=. CRLF E. t
r=. +/b NB. rows
t=. t rplc CRLF;TAB
t=. <;._2 t
p=. mark-fixr,fixc
c=. (#t)%r
index=. (0{p)+i.r
index=. <index ; (1{p)+i.c
t=. fixpaste each t
max=. ((0{p)+r),(1{p)+c
if. +./shape<max do. wd'mb "Paste Error" "Too much data"' return. end.
if. ".'L.',dataname do.
  q=. (r,c)$t
else.
  q=. >".each(r,c)$t
end.
".dataname,'=:q index}',dataname
setnewdata''
)

